##### Canadian Computing Competition: 2019 Stage 1, Senior #3

You are given a grid which contains integers.

Some of the 9 elements in the grid will have a value already, and the remaining elements will be unspecified.

Your task is to determine values for the unspecified elements such that each row, when read from left-to-right is an arithmetic sequence, and that each column, when read from the top-down, is an arithmetic sequence.

Recall that an *arithmetic sequence* of length three is a sequence of integers of the form

for integer values of and . Note that may be any integer, including zero or a negative integer.

#### Input Specification

The input will be 3 lines long. Each line will have three space-separated values. Each value will either be an integer in the range from to , inclusive, or the symbol `X`

.

For 4 of the 15 marks available, there will be at most 3 `X`

symbols in the input.

For an additional 3 of the 15 marks available, all integer values in the input will be between and , inclusive.

For an additional 4 of the 15 marks available, there will be at least 7 `X`

symbols in the input.

For an additional 2 of the 15 marks available, all integer values in the input will be even numbers.

**Due to the official test data being weak, an additional subtask worth 1 mark has been added that consists of tests constructed to break incorrect solutions that AC on the official test data. Data are provided by ** and .

#### Output Specification

The output will be 3 lines long. Each line will have three space-separated integers. All integers that were given in the input must be in the same position (i.e., same row and same column as in the input). All rows and columns must form arithmetic sequences. All integers in the output must be between and , inclusive.

If there is more than one solution, output any solution. There is guaranteed to be at least one solution.

#### Sample Input 1

```
8 9 10
16 X 20
24 X 30
```

#### Sample Output 1

```
8 9 10
16 18 20
24 27 30
```

#### Explanation of Sample Output 1

Notice that the second element of the second row must be and since , then , and thus, this unspecified element must be . A similar argument applies to the second element of the third row.

#### Sample Input 2

```
14 X X
X X 18
X 16 X
```

#### Sample Output 2

```
14 20 26
18 18 18
22 16 10
```

#### Explanation of Sample Output 2

This is one of many possible solutions. For example, another solution is:

```
14 16 18
14 16 18
14 16 18
```

## Comments

pog

Best problem hands down thank you troy

ratio

I'm trying out a backtracking algorithm, but I keep getting TLE. Here's my attempt. How can I speed this up? Or do I have to use a different approach?

You can try a random number generator which generates a random number then tries to "fill" the grid, and continuously do each step until it generates a valid grid.

Will that use a backtracking algorithm?

Ehh don't wanna reveal too much, but kinda? Except it doesn't bank off previous random number generations.

Ok so I submitted a solution that is full marks, but I'm a bit curious, as previous submissions(of the exact same code), I did not get full marks and ended up with TLE. Is it just a thing with solutions that rely on random integer generation?

It's unfortunate that a random solution is easier than the solution proposed in the editorial.

EDIT: and now apparently I have the top submission.

This comment is hidden due to too much negative feedback. Click here to view it.

freaking difficult problem bro

Yes very difficult, and also you apparently can get varied scores if your solution is based on random numbers lmao. I submitted a solution(the same code) that got 13/16, 14/16, 15/16, and 16/16 each once(TLE was the error).

agreed

this is freaking HARD

it's easy to wrap your head around, but hard to put it in the IDE

I think the question itself is not extremely hard, but I dont think it is easy to solve in just 1 hour.

Hey, thanks Troy! ^_^

:C

Plasmatic tryna' XSS DMOJ 👀

Great problem. Who's the author though? :thinking:

it's troy